var FbDatabasejoin = new Class({
	Extends: FbElement,
	
	options:{
		'liveSite':'',
		'popupform':49,
		'id':0,
		'formid':0,
		'key':'',
		'label':'',
		'popwiny':0,
		'windowwidth':360,
		'displayType':'dropdown',
		listid:0
	},
	
	initialize: function(element, options) {
		this.plugin = 'databasejoin';
		this.parent(element, options);
		//if users can add records to the database join drop down
		if(this.options.allowadd === true && this.options.editable !== false) {
			this.startEvent = this.start.bindWithEvent(this);
			this.watchAdd();
			//register the popup window with the form this element is in
			//do this so that the database join drop down can be updated
			oPackage.bindListener('form_' + this.options.popupform, 'form_' + this.options.formid);
		}
		
		this.watchSelect();
		
		if(this.options.showDesc === true) {
			this.element.addEvent('change', this.showDesc.bindWithEvent(this));
		}
	},
	
	watchSelect:function(){
		var sel = this.getContainer().getElement('.toggle-selectoption');
		if(typeOf(sel) !== 'null') {
			sel.addEvent('click', this.selectRecord.bindWithEvent(this));
			//register the popup window with the form this element is in
			//do this so that the database join drop down can be updated
			oPackage.bindListener('table_' + this.options.listid, 'form_' + this.options.formid);
		}
	},
	
	attachedToForm: function()
	{
		this.parent();
	},
	
	watchAdd:function(){
		var b = this.getContainer().getElement('.toggle-addoption');
		//if duplicated remove old events
		b.removeEvents('click');
		b.addEvent('click', this.startEvent);
	},
	
	selectRecord: function(e){
  	e.stop();
  	var id = this.element.id + '-popupwin';
  	var url = this.options.liveSite + "index.php?option=com_fabrik&view=list&tmpl=component&layout=dbjoinselect&_postMethod=ajax&listid=" + this.options.listid;
  	url += "&triggerElement="+this.element.id;
  	url += "&winid="+id;
  	url += "&resetfilters=1";
  	this.windowopts = {
			'id': id,
			title: 'Select',
			contentType: 'xhr',
			loadMethod: 'xhr',
			evalScripts:true,
			contentURL: url,
			width: this.options.windowwidth.toInt(),
			height: 320,
			y: this.options.popwiny,
			'minimizable': false,
			'collapsible': true,
			onContentLoaded: function() {
				Fabrik.Windows[id].fitToContent()
			}
		};
  	var mywin = new Fabrik.Window(this.windowopts);
	},
	
	getValue:function() {
		this.getElement();
		if(!this.options.editable) {
			return this.options.value;
		}
		if(typeOf(this.element) === 'null') {
			return '';
		}
		switch(this.options.display_type) {
			default:
			case 'dropdown':
				if(typeOf(this.element.get('value')) === 'null') {
					return '';
				}
				return this.element.get('value');
				break;
				
			case 'auto-complete':
				return this.element.value;
				break;
			case 'radio':
				var v = '';
				this._getSubElements().each(function(sub) {
					if(sub.checked) {
						v = sub.get('value');
						return v;
					}
					return null;
				});
				return v;
				break;
		}
	},
	
	start: function(e) {
		var url = this.options.liveSite + "index.php?option=com_fabrik&view=form&tmpl=component&_postMethod=ajax&formid=" + this.options.popupform;
		var id = this.element.id + '-popupwin';
		url += "&winid="+id;
		this.windowopts = {
			'id': id,
			title: 'Add',
			contentType: 'xhr',
			loadMethod:'xhr',
			contentURL: url,
			width: this.options.windowwidth.toInt(),
			height: 320,
			y:this.options.popwiny,
			'minimizable':false,
			'collapsible':true,
			onContentLoaded: function() {
				Fabrik.Windows[id].fitToContent()
			}
		};
				
		this.win = new Fabrik.Window(this.windowopts);
		e.stop();
	},
	
	update:function(val) {
		this.getElement();
		if(typeOf(this.element) === 'null') {
			return;
		}
		if (!this.options.editable) {
			this.element.innerHTML = '';
			if(val === '') {
				return;
			}
			//val = val.split(this.options.splitter);
			val = JSON.decode(val);
			//was a security issue as options.data contained unaccessible element data
			//var h = $H(this.options.data);
			var h = this.form.getFormData();
			if (typeOf(h) === 'object') {
				h = $H(h);
			}
			val.each(function(v) {
				if (typeOf(h.get(v)) !== 'null') {
					this.element.innerHTML += h.get(v) + "<br />";
				}else{
					//for detailed view prev/next pagination v is set via elements 
					//getROValue() method and is thus in the correct format - not sure that
					// h.get(v) is right at all but leaving in incase i've missed another scenario 
					this.element.innerHTML += v + "<br />";
				}	
			}.bind(this));
			return;
		}
		this.setValue(val);
	},
	
	setValue:function(val) {
		var found = false;
		if(typeOf(this.element.options) !== 'null') { //needed with repeat group code
			for (var i = 0; i < this.element.options.length; i++) {
				if (this.element.options[i].value == val) {
					this.element.options[i].selected = true;
					found = true;
					break;
				}
			}
		}
		if(!found && this.options.show_please_select) {
			if (this.element.get('tag') == 'input') {
				this.element.value = val;
				if(this.options.display_type == 'auto-complete') {
					//update the field label as well (do ajax as we dont know what the label should be (may included concat etc))
					var myajax = new Ajax({
						'url':this.options.liveSite+'index.php?option=com_fabrik&view=form&format=raw&fabrik='+this.form.id+'&rowid='+val,
						options:{
							'evalScripts':true
						},
						onSuccess:function(r) {
							r = Json.evaluate(r.stripScripts());
							var v = r.data[this.options.key];
							var l = r.data[this.options.label];
							if(typeOf(l) !== 'null'){
								labelfield = this.element.findClassUp('fabrikElement').getElement('.autocomplete-trigger');
								this.element.value = v;
								labelfield.value = l;
							}
						}.bind(this)
					}).send();
				}
			}else{
				if (this.options.displayType == 'dropdown') {
					this.element.options[0].selected = true;
				} else {
					this.element.getElements('input').each(function(i){
						if (i.get('value') == val) {
							i.checked = true;
						}
					});
				}
			}
		}
		this.options.value = val;
	},

	appendInfo: function(data) {
		if(data === '' || typeOf(data.data) === 'null' || this.canAppend === false) {
			this.closeWin();
			return;
		}
		//$$$ rob only update if element found - see http://fabrikar.com/forums/showthread.php?p=100896
		if (typeOf(data.data) != 'array') {
			// only do this for selected row from popup table
			if($H(data.data).getKeys().contains(this.options.element) == false) {
				this.closeWin();
				return;
			}
		} else {
			// popup add form has been submitted - does that form cotain this element's key
			// sub optimal fix here as there could be 2 db joins to the same key
			if($H(data.data[0][0].data).getKeys().contains(this.options.key) == false) {
				return;
			}
		}

		var key = this.options.key;
		var label = this.options.label;
		var rowid = data.rowid;
		var formid = data.formid;
		//var rowid = this.form.form.getElement('input[name=rowid]').get('value');
		data = data.data;
		var url = this.options.liveSite + 'index.php?option=com_fabrik&format=raw&method=ajax_getOptions';
		
		var post = {
							'option':'com_fabrik',
							'format':'raw',
							'task':'plugin.pluginAjax',
							'plugin':'databasejoin',
							'method':'ajax_getOptions',
							'element_id':this.options.id,
							'formid':this.options.formid,
							'rowid':rowid
						};
		var url = this.options.liveSite + 'index.php?option=com_fabrik&view=form&format=raw'
		
		var post = {
							'formid':formid,
							'rowid':rowid
						};
						
			var myajax = new Request.JSON({url:url,
				data :post,
				onSuccess:function(r) {
					//r = JSON.decode(r.stripScripts());
					/*for(var i=0; i<r.length; i++) {
						if(r[i].value == rowid) {
							break;
						}
					}
					var v = r[i].value;
					var l = r[i].text;*/
					var v = r.data[this.options.key];
					var l = r.data[this.options.label];
					
					switch(this.options.display_type) {
						case 'dropdown':
							if(this.element.getElements('option').get('value').contains(v)){
								
							}
							var o = this.element.getElements('option').filter(function(o, x){
								if( o.get('value') == v){
									this.element.selectedIndex = x;
									return true;
								}
							}.bind(this))
							if(o.length == 0) {
								opt = new Element('option', {'value':v,'selected':'selected'}).set('text', l);
								$(this.element.id).adopt(opt);
							}
							break;
					case 'auto-complete':
						labelfield = this.element.findClassUp('fabrikElement').getElement('input[name='+this.element.id+'-auto-complete]');
						this.element.value = v;
						labelfield.value = l;
						break;
					default:
						var o = this.element.getElements('.fabrik_subelement').filter(function(o, x){
							if(o.get('value') == v){
								o.checked = true;
								return true;
							}
						}.bind(this));
						if(o.length == 0) {
							var opt = new Element('div', {
					  		'class': 'fabrik_subelement'
					  	}).adopt(new Element('label').adopt([new Element('input', {
					  		'class': 'fabrikinput',
					  		'type': 'radio',
								'checked':true,
					  		'name': this.options.element,
					  		'value': v
					  	}), new Element('span').set('text', l)]));
							opt.inject($(this.element.id).getElements('.fabrik_subelement').getLast(), 'after');
						}
						break;
				}
					
				if(typeOf(this.element) === 'null') {
					return;
				}
				this.closeWin();
			}.bind(this)
		}).send();
	},
	
	closeWin:function() {
		var id = this.element.id + '-popupwin';
		//this if was at the end of the onSuccess method - but if no data added it wasnt called
		if (typeOf($(id)) !== 'null') {
			Fabrik.Windows[id].close();
		}
	},
	
	getValues:function()
	{
		var v = $A([]);
		var search = (this.options.display_type != 'dropdown') ? 'input' : 'option';
			$(this.element.id).getElements(search).each(function(f) {
				v.push(f.value);
			});
		return v;
	},
	
	cloned: function(c) {
		//c is the repeat group count
		//@TODO this is going to wipe out any user added change events to the element
		// cant' figure out how to just remove the cdd change events.
		this.element.removeEvents('change');
		if(this.options.allowadd === true && this.options.editable !== false) {
			this.startEvent = this.start.bindWithEvent(this);
			this.watchAdd();
		}
		this.watchSelect();
		if(this.options.display_type == 'auto-complete') {
			//update auto-complete fields id and create new autocompleter object for duplicated element
			var f = this.getContainer().getElement('.autocomplete-trigger');
			f.id = this.element.id + '-auto-complete';
			 new FabAutocomplete(this.element.id, this.options.autoCompleteOpts);
		}
	},
	
	addNewEvent: function(action, js) {
		if (action == 'load') {
			this.loadEvents.push(js);
			this.runLoadEvent(js);
			return;
		}
		switch(this.options.displayType){
			case 'dropdown':
			default:
				if (this.element) {
			  	this.element.addEvent(action, function(e) {
			  		e.stop();
			  		(typeOf(js) === 'function') ? js.delay(0) : eval(js);
			  	});
		  	}
				break;
			case 'radio':
				this._getSubElements();
				this.subElements.each(function(el) {
					el.addEvent(action, function(e) {
						(typeOf(js) === 'function')?js.delay(0):eval(js);
					});
				});
				break;
			case 'auto-complete':
				var f = this.getAutoCompleteLabelField();
				if (typeOf(f) !== false) {
					f.addEvent(action, function(e) {
			  		e.stop();
			  		(typeOf(js) === 'function') ? js.delay(0) : eval(js);
			  	});
			  }
				break;
		}
	},
	
	showDesc: function(e) {
  	e = new Event(e);
  	var v = $(e.target).selectedIndex;
  	var c = this.element.findClassUp('fabrikElementContainer').getElement('.dbjoin-description');
  	var show = c.getElement('.description-' + v);
  	c.getElements('.notice').each(function(d) {
  		if (d === show) {
  			var myfx = new Fx.Tween(show, {property:'opacity',
  				duration: 400,
  				transition: Fx.Transitions.linear
  			});
  			myfx.set(0);
  			d.setStyle('display', '');
  			myfx.start(0, 1);
  		} else {
  			d.setStyle('display', 'none');
  		}
  	});
  }
});