/**
 * semi transparent bg to use as overlay when displaying windows.
 */
Overlay = new Class({
	
	initialize:function(){
		this.overlay =  new Element('div', {'id':'fabrikOverlay', 'styles':{'background-color':'#000'}});
		this.overlay.addEvent('click', this.hide.bindWithEvent(this));
		window.addEvent('domready', function(){
			this.overlay.inject(document.body);	
			this.opacityMorph = new Fx.Morph(this.overlay, {
			'duration': 350,
			transition: Fx.Transitions.Sine.easeInOut
			});
		
			this.hide();
		}.bind(this));
	},
	
	fade:function(dir){
		dir = dir ? dir : 'out';
		if (dir == 'out') {
			this.opacityMorph.start({'opacity': 0}).chain(function(){
				this.hide();
			}.bind(this));
		} else {
			this.show();
		}
	},
	
	hide:function(){
		this.opacityMorph.set({
			'opacity': 0
		});
		window.fireEvent('fabrik.overlay.hide');
		window.removeEvent('scroll', this.resize.bindWithEvent(this));
		window.removeEvent('resize', this.resize.bindWithEvent(this));
	},
	
	show:function(){
		this.resize();
		this.overlay.show();
		this.opacityMorph.start({
			'opacity': 0.6
		});
		window.addEvent('scroll', this.resize.bindWithEvent(this));
		window.addEvent('resize', this.resize.bindWithEvent(this));
	},
	
	resize:function(){
		this.overlay.setStyle('width', window.getCoordinates().width);
		this.overlay.setStyle('height', window.getCoordinates().height + window.getScroll().y);
	}
});

/**
 * create the Fabrik name space
 */
if(typeof(Fabrik)==="undefined"){
	var Fabrik={}
	Fabrik.Windows = {};
	window.addEvent('domready', function(){
		Fabrik.tips = new FloatingTips('.fabrikTip', {html:true});
	});
	Fabrik.iconGen = new IconGenerator({scale:0.5});
	Fabrik.overlay = new Overlay();
	
}
