/**
 * @author Robert
 */
 
var FbListPlugin = new Class({
	Implements:[Events, Options],
	options : {},
	initialize: function(tableform, options) {
		this.setOptions(options);
		window.addEvent('domready', function(){
			this.tableform = document.id(tableform);
		}.bind(this));
	},
	clearFilter:Function.from()
});

var FbListFilter = new Class({
 	
	Implements:[Options, Events],
	
	options:{
    'container': '',
		'type':'list',
		'id':''
  },
  
 	initialize:function(options){
 		this.filters = $H({});
 		this.setOptions(options);
		this.container = document.id(this.options.container);
		if(typeOf(this.container) === 'null'){
			return;
		}
		var c = this.container.getElement('.clearFilters');
		if(typeOf(c) !== 'null'){
			c.removeEvents();
			c.addEvent('click', function(e){
				new Event(e).stop();
				this.container.getElements('.fabrik_filter').each(function(f){
					if(f.get('tag') == 'select'){
						f.selectedIndex = 0;
					}else{
						f.value = '';
					}
				});
				top.oPackage.blocks.get(this.options.type+'_'+this.options.id).plugins.each(function(p){
					p.clearFilter();
				})
				new Element('input', {'name':'resetfilters', 'value':1, 'type':'hidden', 'type':'hidden'}).inject(this.container);
				if (this.options.type == 'list') {
					top.oPackage.submitfabrikList(this.options.id, 'list.filter');
				}else{
					this.container.getElement('form[name=filter]').submit();
				}
			}.bind(this));
		}
 	},
 	
 	addFilter:function(plugin, f){
 		if(this.filters.has(plugin) === false){
 			this.filters.set(plugin, []);
 		}
 		this.filters.get(plugin).push(f);
 	},
 	
 	// $$$ hugh - added this primarily for CDD element, so it can get an array to
	// emulate submitted form data
 	// for use with placeholders in filter queries. Mostly of use if you have
	// daisy chained CDD's.
	getFilterData : function() {
		var h = {};
		this.container.getElements('.fabrik_filter').each(function(f){
			if (f.id.test(/value$/)) {
				var key = f.id.match(/(\S+)value$/)[1];
				// $$$ rob added check that something is select - possbly causes js
				// error in ie
				if (f.get('tag') == 'select' && f.selectedIndex !== -1) {
					h[key] = document.id(f.options[f.selectedIndex]).get('text');
				}
				else {
					h[key] = f.get('value');	
				}
				h[key + '_raw'] = f.get('value');
			}
		}.bind(this));
		return h;
	},
 	
 	update: function(){
 		this.filters.each(function(fs, plugin){
 			fs.each(function(f){
 				f.update();
 			}.bind(this));
 		}.bind(this));
 	}
});

 
var FbList = new Class({
	
	Implements:[Options, Events, Plugins],
	
	options:{
    'admin': false,
		'filterMethod':'onchange',
    'postMethod': 'post',
    'form': 'listform_' + this.id,
    'hightLight': '#ccffff',
    'primaryKey': '',
    'headings': [],
    'labels':{},
    'Itemid': 0,
    'formid': 0,
    'canEdit': true,
    'canView': true,
    'page': 'index.php',
    'formels':[], // elements that only appear in the form
    'data': [], // [{col:val, col:val},...] (depreciated)
    'rowtemplate':''
  },
  
  initialize: function(id, options){
    this.id = id;
    this.listenTo = $A([]);
    this.setOptions(options);
		
		window.addEvent('domready', function(){
			this.getForm();
	    this.table = document.id('list_' + id);
	    if (this.table) {
	      this.tbody = this.table.getElement('tbody');
	      if (typeOf(this.tbody) === 'null') {
	      	this.tbody = this.table;
	      }
				// $$$ rob mootools 1.2 has bug where we cant set('html') on table
				// means that there is an issue if table contains no data
				if (window.ie) {
					this.options.rowtemplate = this.table.getElement('.fabrik_row');
				}
	    }
			this.watchAll();
		}.bind(this));
  },
	
	watchAll: function()
	{
		this.watchNav();
		this.watchRows();
		this.watchFilters();
		this.watchOrder();
		this.watchEmpty();
		this.watchButtons();
	},
	
	watchButtons: function()
	{
		this.exportWindowOpts = {
			id: 'exportcsv',
			title: 'Export CSV',
			loadMethod:'html',
			minimizable:false,
			width: 320,
			height: 120,
			content:''		
		};
	
		if(this.form.getElements('.csvExportButton')){
			this.form.getElements('.csvExportButton').each(function(b){
				if(b.hasClass('custom') === false){
					b.addEvent('click', function(e){
						e = new Event(e).stop();
						var thisc = this.makeCSVExportForm();
						this.form.getElements('.fabrik_filter').each(function(f){
							var fc = new Element('input', {'type':'hidden','name':f.name,'id':f.id,'value':f.get('value')});
							fc.inject(thisc);
						}.bind(this));
						this.exportWindowOpts.content = thisc;
						
						this.exportWindowOpts.onContentLoaded = function(){
							(function(){
								Fabrik.Windows['exportcsv'].fitToContent();
								}).delay(700);
						}
						var win = new Fabrik.Window(this.exportWindowOpts);
					}.bind(this));
				}
			}.bind(this));
		}
	},
	
	makeCSVExportForm:function(){
		// cant build via dom as ie7 doesn't accept checked status
		var rad = "<input type='radio' value='1' name='incfilters' checked='checked' />" + Joomla.JText._('JYES');
		var rad2 = "<input type='radio' value='1' name='incraw' checked='checked' />" + Joomla.JText._('JYES');
		var rad3 = "<input type='radio' value='1' name='inccalcs' checked='checked' />" + Joomla.JText._('JYES');
		var rad4 = "<input type='radio' value='1' name='inctabledata' checked='checked' />" + Joomla.JText._('JYES');
	
		var url = 'index.php?option=com_fabrik&view=list&listid='+this.id+'&format=csv';

		var divopts = {'styles':{'width':'200px','float':'left'}};
		var c = new Element('form', {'action':url, 'method':'post'}).adopt([
			
		new Element('div', divopts).appendText(Joomla.JText._('COM_FABRIK_INCLUDE_FILTERS')),
		new Element('label').set('html',rad),
		new Element('label').adopt([
			new Element('input', {'type':'radio','name':'incfilters','value':'0'}), 
			new Element('span').appendText(Joomla.JText._('JNO'))
		]),
		new Element('br'),
		new Element('div', divopts).appendText(Joomla.JText._('COM_FABRIK_INCLUDE_DATA')),
		new Element('label').set('html',rad4),
		new Element('label').adopt([
			new Element('input', {'type':'radio','name':'inctabledata','value':'0'}), 
			new Element('span').appendText(Joomla.JText._('JNO'))
		]),
		new Element('br'),
		new Element('div', divopts).appendText(Joomla.JText._('COM_FABRIK_INCLUDE_RAW_DATA')),
		new Element('label').set('html',rad2),
		new Element('label').adopt([
			new Element('input', {'type':'radio','name':'incraw','value':'0'}), 
			new Element('span').appendText(Joomla.JText._('JNO'))
		]),
		new Element('br'),
		new Element('div', divopts).appendText(Joomla.JText._('COM_FABRIK_INLCUDE_CALCULATIONS')),
		new Element('label').set('html',rad3),
		new Element('label').adopt([
			new Element('input', {'type':'radio','name':'inccalcs','value':'0'}), 
			new Element('span').appendText(Joomla.JText._('JNO'))
		])
		]);
		new Element('h4').appendText(Joomla.JText._('COM_FABRIK_SELECT_COLUMNS_TO_EXPORT')).inject(c);
		var g = '';
		var i = 0;
		$H(this.options.labels).each(function(label, k){
			if (k.substr(0, 7) != 'fabrik_') {
	  		var newg = k.split('___')[0];
				if(newg !== g){
					g = newg;
					new Element('h5').set('text', g).inject(c);
				}
				var rad = "<input type='radio' value='1' name='fields["+k+"]' checked='checked' />" + Joomla.JText._('JYES');
			  label =  label.replace(/<\/?[^>]+(>|$)/g, "");
				var r = new Element('div', divopts).appendText(label);
				r.inject(c);
				new Element('label').set('html',rad).inject(c);
				new Element('label').adopt([
				new Element('input', {'type':'radio','name':'fields['+k+']','value':'0'}), 
				new Element('span').appendText(Joomla.JText._('JNO'))
				]).inject(c);
				new Element('br').inject(c);
	  	}
			i++;
		}.bind(this)); 
		
		// elements not shown in table
		if(this.options.formels.length > 0){ 
			new Element('h5').set('text', Joomla.JText._('COM_FABRIK_FORM_FIELDS')).inject(c);
			this.options.formels.each(function(el){
				var rad = "<input type='radio' value='1' name='fields["+el.name+"]' checked='checked' />" + Joomla.JText._('JYES');
				var r = new Element('div', divopts).appendText(el.label);
				r.inject(c);
				new Element('label').set('html',rad).inject(c);
					new Element('label').adopt([
					new Element('input', {'type':'radio','name':'fields['+el.name+']','value':'0'}), 
					new Element('span').appendText(Joomla.JText._('JNO'))
					]).inject(c);
					new Element('br').inject(c);	
			}.bind(this));
		}
		
		new Element('div', {'styles':{'text-align':'right'}}).adopt(
			new Element('input', {'type':'button','name':'submit','value':Joomla.JText._('COM_FABRIK_EXPORT'), 'class':'button', events:{
				'click':function(e){
					e = new Event(e);
					e.stop();
					e.target.disabled = true;
					new Element('div', {'id': 'csvmsg'}).set('html',Joomla.JText._('COM_FABRIK_LOADING')+' <br /><span id="csvcount">0</span> / <span id="csvtotal"></span> '+Joomla.JText._('COM_FABRIK_RECORDS') + '.<br/> '+Joomla.JText._('COM_FABRIK_SAVING_TO')+' <span id="csvfile"></span>').inject(e.target, 'before');
					var url = 'index.php?option=com_fabrik&view=list&format=csv&listid='+this.id;
					this.triggerCSVImport(0, url);
				}.bind(this)
				
			}})
		).inject(c);
		new Element('input', {'type':'hidden','name':'view','value':'table'}).inject(c);
		new Element('input', {'type':'hidden','name':'option','value':'com_fabrik'}).inject(c);
		new Element('input', {'type':'hidden','name':'listid','value':this.id}).inject(c);
		new Element('input', {'type':'hidden','name':'format','value':'csv'}).inject(c);
		new Element('input', {'type':'hidden','name':'c','value':'table'}).inject(c);
		return c;
	},
	
	triggerCSVImport:function(start, url){
		var opts = {};
		if (typeOf(document.id('exportcsv')) !== 'null') {
			$A(['incfilters', 'inctabledata', 'incraw', 'inccalcs']).each(function(v){
				var inputs = document.id('exportcsv').getElements('input[name=' + v + ']');
				if (inputs.length > 0) {
					opts[v] = inputs.filter(function(i){
						return i.checked;
					})[0].value;
				}
			});
			// selected fields
			var fields = {};
			document.id('exportcsv').getElements('input[name^=field]').each(function(i){
				if(i.checked){
					var k = i.name.replace('fields[', '').replace(']', '');
					fields[k] = i.get('value');
				}
			});
		}
		opts['fields'] = fields;
		var thisurl = url +'&start='+start;
		var myAjax = new Request.JSON({
			url:thisurl,
			method: 'post',
			data:opts,
			onSuccess: function(res){
					if (typeOf(document.id('csvcount')) !== 'null') document.id('csvcount').set('text', res.count);
					if (typeOf(document.id('csvtotal')) !== 'null') document.id('csvtotal').set('text', res.total);
					if (typeOf(document.id('csvfile')) !== 'null') document.id('csvfile').set('text', res.file);
					if (res.count < res.total) {
						this.triggerCSVImport(res.count, url);
					}else{
						var finalurl = top.oPackage.options.liveSite+'index.php?option=com_fabrik&view=list&format=csv&listid='+this.id+'&start='+res.count;
						var msg = Joomla.JText._('COM_FABRIK_CSV_COMPLETE');
						msg += ' <a href="'+finalurl+'">'+Joomla.JText._('COM_FABRIK_CSV_DOWNLOAD_HERE')+'</a>';
						if (typeOf(document.id('csvmsg')) !== 'null') document.id('csvmsg').set('html', msg);
					}
			}.bind(this)
		});
		myAjax.send();
	},
	
	addPlugins:function(a){
		// $$$ rob shouldnt have been this.plugins but leaving here in case ppl use
		// it
		// should be this.options.plugins to get things to play nicely with the
		// implemented plugins class
		this.plugins = a;
		this.options.plugins = a;
		window.addEvent('domready', function(e){
			// delay for use in mocha win
			var delay = window.ie ? 1000 : 0;
			(function(){
			this.runPlugins('onAttach', e);
			}.bind(this)).delay(2000);
		}.bind(this));
		
	},
	
	watchEmpty: function(e){
		var b = document.id(this.options.form).getElement('input[name=doempty]', this.options.form);
		if (b) {
			b.addEvent('click', function(e){
				var event = new Event(e).stop();
				if( confirm(Joomla.JText._('COM_FABRIK_CONFIRM_DROP'))){
					top.oPackage.submitfabrikList(this.id, 'list.doempty');
				}
			}.bind(this));
		}
	},
	
	watchOrder: function(){
		var hs = document.id(this.options.form).getElements('.fabrikorder, .fabrikorder-asc, .fabrikorder-desc');
		hs.removeEvents('click');
		hs.each(function(h){
			h.addEvent('click', function(event){
				var e = new Event(event);
				
				var orderdir = '';
				var newOrderClass = '';
				// $$$ rob in pageadaycalendar.com h was null so reset to e.target
				var h = document.id(e.target);
				var td = h.findClassUp('fabrik_ordercell');
				if (h.tagName !== 'a') {
					var h = td.getElement('a');
				}
				switch(h.className){
					case 'fabrikorder-asc':
						newOrderClass = 'fabrikorder-desc';
						orderdir = 'desc';
						break;
					case 'fabrikorder-desc':
						newOrderClass = 'fabrikorder';
						orderdir = "-";
						break;
					case 'fabrikorder':
						newOrderClass = 'fabrikorder-asc';
						orderdir = 'asc';
						break;
				}
				td = td.className.split(' ')[2].replace('_order', '').replace(/^\s+/g,'').replace(/\s+$/g,'');// chrome
																																																			// and
																																																			// safari
																																																			// you
																																																			// need
																																																			// to
																																																			// trim
																																																			// whitespace
				h.className = newOrderClass;
				this.fabrikNavOrder(td, orderdir);
				e.stop();
			}.bind(this));
		}.bind(this));
	
	},
	
	watchFilters: function(){
		var e = '';
		if (this.options.filterMethod != 'submitform') {
			document.id(this.options.form).getElements('.fabrik_filter').each(function(f){
				e = f.get('tag') == 'select' ? 'change' : 'blur';
				f.removeEvent(e);
				f.addEvent(e, function(e){
					new Event(e).stop();
					top.oPackage.submitfabrikList(this.id, 'list.filter');
				}.bind(this));
			}.bind(this));
		}else{
			var f = document.id(this.options.form).getElement('.fabrik_filter_submit');
			if (f) {
				f.removeEvents();
				f.addEvent('click', function(e){
					top.oPackage.submitfabrikList(this.id, 'list.filter');
				}.bind(this));
			}
		}
		document.id(this.options.form).getElements('.fabrik_filter').addEvent('keydown', function(e){
			e = new Event(e);
			if (e.code == 13) {
				e.stop();
				top.oPackage.submitfabrikList(this.id, 'list.filter');
			}
		}.bind(this));
	},
  
  // highlight active row, deselect others
  setActive: function(activeTr){
    this.table.getElements('.fabrik_row').each(function(tr){
      tr.removeClass('activeRow');
    });
    activeTr.addClass('activeRow');
  },
  
  watchRows: function(){
    if(!this.table){
			return;
		}
    this.rows = this.table.getElements('.fabrik_row');
		this.links = this.table.getElements('.fabrik___rowlink');
    if (this.options.ajaxEditViewLink) {
      var view = '';
      if (this.options.canEdit == 1) {
        view = 'form';
      }
      else {
        if (this.options.canView == 1) {
          view = 'details';
        }
      }
      // @TODO this isnt working when in CB plugin mode
      var editopts = {
        option: 'com_fabrik',
        'Itemid': this.options.Itemid,
        'view': view,
        'listid': this.id,
        'fabrik': this.options.formid,
        'rowid': 0,
        'format': 'raw',
        '_senderBlock': 'list_' + this.id
      };
      this.links.each(function(link){
        link.addEvent('click', function(e){
          var tr = link.findUp('tr');
					this.setActive(tr);
					top.oPackage.startLoading();
          editopts.rowid = tr.id.replace('list_' + this.id + '_row_', '');
          var url = "index.php?" + Object.toQueryString(editopts);
          var myAjax = new Ajax(url, {
            method: 'get',
            onComplete: function(res){
            	top.oPackage.sendMessage('list_' + this.id, 'update', 'ok', res);
            }.bind(this)
          });
          myAjax.request();
          e = new Event(e);
          e.stop();
        }.bind(this));
      }.bind(this));
    }
    
    // view details
    
    this.links = this.table.getElements('.fabrik___viewrowlink');
    if (this.options.postMethod != 'post') {
      view =  'details';
      opts = {
        option: 'com_fabrik',
        'Itemid': this.options.Itemid,
        'view': view,
        'listid': this.id,
        'fabrik': this.options.formid,
        'rowid': 0,
        'format': 'raw',
        '_senderBlock': 'list_' + this.id
      };
      this.links.each(function(link){
        link.addEvent('click', function(e){
          var tr = link.findUp('tr');
					this.setActive(tr);
					top.oPackage.startLoading();
          opts.rowid = tr.id.replace('list_' + this.id + '_row_', '');
          var url = "index.php?" + Object.toQueryString(opts);
          var myAjax = new Ajax(url, {
            method: 'get',
            onComplete: function(res){
            	top.oPackage.sendMessage('list_' + this.id, 'update', 'ok', res);
            }.bind(this)
          });
          myAjax.request();
          e = new Event(e);
          e.stop();
        }.bind(this));
      }.bind(this));
    }
  },
  
  getForm: function(){
		if (!this.form) {
			this.form = document.id(this.options.form);
		}
		return this.form;
  },
  
  submitfabrikList: function(task){
    this.getForm();
		if (task == 'list.delete') {
			var ok = false;
			this.form.getElements('input[name^=ids]').each(function(c){
				if(c.checked){
					ok = true;
				}
			});
			if(!ok){
				alert(Joomla.JText._('COM_FABRIK_SELECT_ROWS_FOR_DELETION'));
				top.oPackage.stopLoading('list_' + this.id);
				return false;
			}
			if(!confirm(Joomla.JText._('COM_FABRIK_CONFIRM_DELETE'))){
				top.oPackage.stopLoading('list_' + this.id);
				return;
			}
		}
    if (task == 'list.filter') {
			this.form.task.value = task;
      if (this.form['limitstart' + this.id]) {
        this.form.getElement('#limitstart' + this.id).value = 0;
      }
    } else {
      if (task !== '') {
        this.form.task.value = task;
      }
    }
    if (this.options.postMethod == 'ajax') {

	    // for module & mambot
			// $$$ rob with modules only set view/option if ajax on
			this.form.getElement('input[name=option]').value = 'com_fabrik';
			this.form.getElement('input[name=view]').value = 'list';
			this.form.getElement('input[name=format]').value = 'raw';
       
      	this.form.set('send', {onComplete: function(json){
      		top.oPackage.sendMessage('list_' + this.id, task, 'ok', json);
        }.bind(this)});
      	this.form.send();
      	window.fireEvent('fabrik.table.submit', [task, this.form.toQueryString().toObject()]);
    }
    else {
      this.form.submit();
    }
    return false;
  },
  
  fabrikNav: function(limitStart){
    this.form.getElement('#limitstart' + this.id).value = limitStart;
    // cant do filter as that resets limitstart to 0
    if(!this.runPlugins('onNavigate', null)){
    	return false;
    }
    top.oPackage.submitfabrikList(this.id, 'list.view');
    return false;
  },
  
  fabrikNavOrder: function(orderby, orderdir){
  	this.form.orderby.value = orderby;
    this.form.orderdir.value = orderdir;
    if(!this.runPlugins('onOrder', null)){
    	return false;
    }
    top.oPackage.submitfabrikList(this.id, 'list.order');
  },
  
  removeRows: function(rowids){
    // @TODO: try to do this with FX.Elements
    for (i = 0; i < rowids.length; i++) {
      var row = document.id('list_' + this.id + '_row_' + rowids[i]);
      var highlight = new Fx.Morph(row, {
        duration: 1000
      });
      highlight.start({
        'backgroundColor': this.options.hightLight
      }).chain(function(){
        this.start({
          'opacity': 0
        });
      }).chain(function(){
        row.dispose();
        this.checkEmpty();
      }.bind(this));
    }
  },
  
  editRow: function(){
  
  },
  
  clearRows: function(){
  	this.table.getElements('.fabrik_row').each(function(tr){
      tr.dispose();
    });
  },
  
	
  updateRows: function(data){
		if (data.id == this.id && data.model == 'list') {
			var header = document.id(this.options.form).getElements('.fabrik___heading').getLast();
			var headings = new Hash(data.headings);
			headings.each(function(data, key){
				key = "." + key + '_heading';
					try{
						if (typeOf(header.getElement(key)) !== 'null') {
						header.getElement(key).set('html',data);
						}
					}catch(err){
						fconsole(err);
					}
			});
			
			this.clearRows();
			var counter = 0;
			var rowcounter = 0;
			trs = [];
			//$H needed in http://www.ilibrium.com/cbx2/
			$H(data.data).each(function(groupData, groupKey){
				for(i=0;i<groupData.length;i++){
					if (typeOf(this.options.rowtemplate) == 'string') {
						var container =(!this.options.rowtemplate.match(/\<tr/)) ? 'div' : 'table';
						var thisrowtemplate = new Element(container);
		  			thisrowtemplate.set('html',this.options.rowtemplate);
				  }else{
						container = this.options.rowtemplate.get('tag') == 'tr' ? 'table' : 'div'; 
						var thisrowtemplate = new Element(container);
						// ie tmp fix for mt 1.2 setHTML on table issue
						thisrowtemplate.adopt(this.options.rowtemplate.clone());
					}
					row = $H(groupData[i]);
					$H(row.data).each(function(val, key){
						var rowk = '.' + key;
						var cell = thisrowtemplate.getElement(rowk);
						if (typeOf(cell) !== 'null') {
							cell.set('html',val);
						}
						rowcounter ++;
          }.bind(this));
					// thisrowtemplate.getElement('.fabrik_row').id = 'list_' + this.id +
					// '_row_' + row.get('__pk_val');
					thisrowtemplate.getElement('.fabrik_row').id = row.id;
					if (typeOf(this.options.rowtemplate) === 'string') {
						var c = thisrowtemplate.getElement('.fabrik_row').clone();
						c.id = row.id;
				  	c.inject(this.tbody);
				  }else{
						var r = thisrowtemplate.getElement('.fabrik_row');
						r.inject(this.tbody);
						thisrowtemplate.empty();
					}
					counter ++;
				}
      }.bind(this));
			
			var fabrikDataContainer = this.table.findClassUp('fabrikDataContainer');
			var emptyDataMessage = this.table.findClassUp('fabrikForm').getElement('.emptyDataMessage');
			if (rowcounter == 0) {
				if(typeOf(fabrikDataContainer)!== 'null')
					fabrikDataContainer.setStyle('display', 'none');
				if(typeOf(emptyDataMessage)!== 'null')
					emptyDataMessage.setStyle('display', '');	
			}else{
				if(typeOf(fabrikDataContainer)!== 'null')
					fabrikDataContainer.setStyle('display', '');
				if(typeOf(emptyDataMessage)!== 'null')
					emptyDataMessage.setStyle('display', 'none');	
			}
			
			if (typeOf(this.form.getElement('.fabrikNav')) !== 'null') {
				this.form.getElement('.fabrikNav').set('html', data.htmlnav);
			}
      this.watchAll();
      window.fireEvent('fabrik.table.updaterows');
      try{
				Slimbox.scanPage();
			}catch(err){
				fconsole('slimbox scan:'+err);
			}
			try{
				Mediabox.scanPage();
			}catch(err){
				fconsole('mediabox scan:'+err);
			}
		}
		 this.stripe();
		 oPackage.stopLoading('list_' + this.id);
  },
  
  addRow: function(obj){
    var r = new Element('tr', {
      'class': 'oddRow1'
    });
    var x = {
      test: 'hi'
    };
    for (var i in obj) {
      if (this.options.headings.indexOf(i) != -1) {
        var td = new Element('td', {}).appendText(obj[i]);
        // td.colSpan = c;
        r.appendChild(td);
      }
    }
    r.inject(this.tbody);
  },
  
  addRows: function(aData){
    for (i = 0; i < aData.length; i++) {
      for (j = 0; j < aData[i].length; j++) {
        this.addRow(aData[i][j]);
      }
    }
    this.stripe();
  },
  
  stripe: function(){
  	var trs = this.table.getElements('.fabrik_row');
    for (i = 0; i < trs.length; i++) {
      if (i !== 0) { // ignore heading
        var row = 'oddRow' + (i % 2);
        trs[i].addClass(row);
      }
    }
  },
  
  checkEmpty: function(){
  	var trs = this.table.getElements('tr');
    if (trs.length == 2) {
      this.addRow({
        'label': Joomla.JText._('COM_FABRIK_NO_RECORDS')
      });
    }
  },
  
  watchCheckAll: function(e){
  	var checkAll = this.form.getElement('input[name=checkAll]');
    if (typeOf(checkAll) !== 'null') {
    	// IE wont fire an event on change until the checkbxo is blurred!
      checkAll.addEvent('click', function(e){
      	var event = new Event(e);
   	  	var c = document.id(event.target); 
        var chkBoxes = this.table.findClassUp('fabrikList').getElements('input[name^=ids]');
				var c = !c.checked ? '' : 'checked';
        for (var i = 0; i < chkBoxes.length; i++) {
          chkBoxes[i].checked = c;
					this.toggleJoinKeysChx(chkBoxes[i]);
        }
        // event.stop(); dont event stop as this stops the checkbox being
				// selected
      }.bind(this));
    }
		this.form.getElements('input[name^=ids]').each(function(i){
			i.addEvent('change', function(e){
				this.toggleJoinKeysChx(i);
			}.bind(this));
		}.bind(this));
  },
	
	toggleJoinKeysChx:function(i)
	{
		i.getParent().getElements('input[class=fabrik_joinedkey]').each(function(c){
			c.checked = i.checked;
		});
	},
  
  watchNav: function(e){
  	var limitBox = this.form.getElement('#limit'+ this.id);
    if (limitBox) {
    	limitBox.removeEvents();
      limitBox.addEvent('change', function(e){
      	if(!this.runPlugins('onLimit', e)){
      		return false;
      	}
      	top.oPackage.submitfabrikList(this.id, 'list.filter');
      }.bind(this));
    }
    var addRecord = this.form.getElement('.addRecord')
    if (document.id(addRecord) && (this.options.ajaxEditViewLink != '0')) {
    	/*
			 * addRecord.removeEvents(); addRecord.addEvent('click', function(e){
			 * e.stop(); top.window.fireEvent('fabrik.list.add', this); }.bind(this));
			 */
    }
    var del = this.form.getElement('input[name=delete]');
    if (del) {
    	del.addEvent('click', function(e){
    		top.oPackage.submitfabrikList(this.id, 'list.delete');
    	}.bind(this))
    }
    
		
		if(document.id('fabrik__swaptable')){
			document.id('fabrik__swaptable').addEvent('change', function(event){
				var e = new Event(event);
				var v = e.target;
				window.location = 'index.php?option=com_fabrik&task=list.view&cid=' + v.get('value');
			}.bind(this));
		}
		if(this.options.postMethod != 'post'){
			if(typeOf(this.form.getElement('.pagination')) !== 'null'){
				this.form.getElement('.pagination').getElements('.pagenav').each(function(a){
					a.addEvent('click', function(e){
						new Event(e).stop();
						if(a.get('tag') == 'a'){
							var o = a.href.toObject();
							this.fabrikNav(o['limitstart' + this.id]);
						}
					}.bind(this));
				}.bind(this));
			}
		}
    this.watchCheckAll();
  },
  
  // todo: refractor addlistento into block class
  addListenTo: function(blockId){
    this.listenTo.push(blockId);
  },
  
  receiveMessage: function(senderBlock, task, taskStatus, data){
    if (this.listenTo.indexOf(senderBlock) != -1) {
      switch (task) {
        case 'delete':
          // this.removeRows(data);
          // this.stripe();
        	this.updateRows(data);
          break;
        case 'processForm':
          this.addRows(data);
          break;
        case 'navigate':
        case 'list.filter':
        case 'updateRows':
        case 'order':
        case 'doPlugin':
        	// only update rows if no errors returned
        	if ($H(data.errors).getKeys().length === 0){
          	this.updateRows(data);
          }
          break;
      }
    }
  }
});