Fabrik.Window = new Class({

	Implements:[Options, Events],
	
	options:{
		id:'FabrikWindow',
		title:'',
		container:false,
		loadMethod:'html',
		contentURL:'',
		createShowOverLay:true,
		onContentLoaded: (function(){})
	},
	
	modal: false,
	
	initialize:function(opts)
	{
		if (Fabrik.Windows[this.options.id]) {
			Fabrik.overlay.show();
			//this = Fabrik.Windows[this.options.id];
		} else {
			this.setOptions(opts);
			if(this.options.createShowOverLay){
				Fabrik.overlay.show();
			}
			this.makeWindow();
		}
	},
	
	makeWindow:function()
	{
		var d = {'width':this.options.width+'px', 'height':this.options.height+'px'};
		d.top = window.getSize().y/2 + window.getScroll().y;
		d.left = window.getSize().x/2  + window.getScroll().x - this.options.width/2;
		this.window = new Element('div', {'id':this.options.id, 'class':'fabrikWindow'}).setStyles(d);
		this.contentWrapperEl = this.window;
		var art = Fabrik.iconGen.create(icon['cross']);
		var del = new Element('a', {'href':'#', 'class':'close', 'events':{
			'click':this.close.bindWithEvent(this)
		}});
		art.inject(del);
		
		var hclass = 'handlelabel';
		if (!this.modal){
			hclass += ' draggable';
			var draggerC = new Element('div', {'class':'bottomBar'});
			var dragger = new Element('div', {'class':'dragger'});
			draggerC.adopt(dragger);
		}
		var label = new Element('span', {'class':hclass}).set('text', this.options.title);
		this.handle = new Element('div', {'class':'handle'}).adopt([label, del]);
		
		this.contentWrapperEl = new Element('div.contentWrapper', {
			'styles':{'overflow':'hidden'}
		});
		this.contentEl = new Element('div', {'class':'itemContent'});
		this.contentWrapperEl.adopt(this.contentEl);
		if (this.modal) {
			var ch = this.options.height-30;
			cw = this.options.width ;
			this.contentWrapperEl.setStyles({'height':ch+'px', 'width':cw+'px'});
			this.window.adopt([this.handle, this.contentEl]);
		}else{
			this.window.adopt([this.handle, this.contentWrapperEl, draggerC]);
			this.window.makeResizable({'handle':dragger,
				onDrag: function(){
					window.fireEvent('fabrik.window.resized', this.window);
					this.drawWindow();
				}.bind(this)
			});
			var dragOpts = {'handle':this.handle};
			dragOpts.onComplete = function(){
					window.fireEvent('fabrik.window.moved', this.window);
					this.drawWindow();
				}.bind(this)
			dragOpts.container = this.options.container ?	$(this.options.container) : null;
			this.window.makeDraggable(dragOpts);
		}

		document.body.adopt(this.window);
		Fabrik.Windows[this.options.id] = this;
		switch(this.options.loadMethod){
			
			case 'html':
				if (typeOf(this.options.content) == 'element'){
					this.options.content.inject(this.contentEl);
				}else{
					this.contentEl.setHTML(this.options.content);
				}
				this.fireEvent('onContentLoaded', [this]);
				break;
			case 'xhr':
				var u = this.window.getElement('.itemContent');
				new Request.HTML({
					'url':this.options.contentURL,
					'update':u,
					onComplete:function(){
						this.fireEvent('onContentLoaded', [this]);
					}.bind(this)
				}).post();
			case 'iframe':
			
				var h = this.contentEl.getScrollSize().y < window.getHeight() ? this.contentEl.getScrollSize().y : window.getHeight();
				var w = this.contentEl.getScrollSize().x + 40 < window.getWidth() ? this.contentEl.getScrollSize().x + 40 : window.getWidth();
	
	
				this.iframeEl = new Element('iframe', {
				'id': this.options.id + '_iframe',
				'name': this.options.id + '_iframe',
				'class': 'fabrikWindowIframe',
				'src': this.options.contentURL,
				'marginwidth': 0,
				'marginheight': 0,
				'frameBorder': 0,
				'scrolling': 'auto',
				'styles': {
					'height': h,
					'width': w
				}
			}).injectInside(this.window.getElement('.itemContent'));
		
				this.iframeEl.addEvent('load', function(e) {
					this.fireEvent('onContentLoaded', [this]);
				}.bind(this));
				break;
		}
		
		window.addEvent('fabrik.overlay.hide', function(){
			this.window.hide();
		}.bind(this));
	},
	
	drawWindow: function(){
		// Resize iframe when window is resized
		if (this.options.loadMethod === 'iframe') {
			this.iframeEl.setStyle('height', this.contentWrapperEl.offsetHeight - 40);
			this.iframeEl.setStyle('width', this.contentWrapperEl.offsetWidth - 10);
		}else{
			this.contentWrapperEl.setStyle('height', this.window.getDimensions().height - this.handle.getDimensions().height  - 40);
			this.contentWrapperEl.setStyle('width', this.window.getDimensions().width - 10);
		}
	},
	
	fitToContent: function(){
		var myfx = new Fx.Scroll(window).toElement(this.window);
		if (this.options.loadMethod !== 'iframe') {
			var contentWrapperEl = this.contentWrapperEl;
			var contentEl = this.contentEl;
			var h = contentEl.getScrollSize().y < window.getHeight() ? contentEl.getScrollSize().y : window.getHeight();
			var w = contentEl.getScrollSize().x + 40 < window.getWidth() ? contentEl.getScrollSize().x + 40 : window.getWidth();
			//var h = contentWrapperEl.getScrollSize().y < window.getHeight() ? contentWrapperEl.getScrollSize().y : window.getHeight();
			//var w = contentWrapperEl.getScrollSize().x + 40 < window.getWidth() ? contentWrapperEl.getScrollSize().x + 40 : window.get

			this.window.setStyle('height', h);
			this.window.setStyle('width', w);
			
		}
		this.drawWindow();
	},
	
	close:function(e)
	{
		if(e){e.stop()};
		Fabrik.overlay.hide();
		//cant destroy as we want to be able to reuse them (see crop in fileupload element)
		this.window.hide();
	},
	
	open:function(e){
		if(e){e.stop()};
		Fabrik.overlay.show();
		this.window.show();
	},
	
	showSpinner:function()
	{
		fconsole('need to do show spinner for window.js');
	},
	
	hideSpinner:function(){
		fconsole('need to do hide spinner for window.js');
	}
	
});

Fabrik.Modal = new Class({
	Extends: Fabrik.Window,
	
	modal:true
	
});
